datablock ParticleData(PRifleHALOExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0 0.0 0.7 0.5";
	colors[1]     = "0 0.0 0.7 0.5";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(PRifleHALOExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "gunExplosionParticle";

   useEmitterColors = true;
   uiName = "Plasma Rifle Dust";
};


datablock ParticleData(PRifleHALORingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 0.0 0.7 0.5";
	colors[1]     = "0 0.0 0.7 0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PRifleHALORingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PRifleHALORingParticle";

   useEmitterColors = true;
   uiName = "Plasma Rifle Ring";
};

datablock ExplosionData(PRifleHALOExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = PrifleHALOExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = PRifleHALORingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};




datablock ParticleData(PRifleHALOTrailParticle)

{
	dragCoefficient		= 0.0;
	
	windCoefficient		= 0.0;
	
	gravityCoefficient	= 0.0;
	
	inheritedVelFactor	= 0.0;
	
	constantAcceleration	= 0.0;
	
	lifetimeMS		= 10;
	
	lifetimeVarianceMS	= 0;
	
	spinSpeed		= 0.0;
	
	spinRandomMin		= 0.0;
	
	spinRandomMax		= 0.0;
	useInvAlpha		= false;
	
	animateTexture		= false;
	//framesPerSec		= 1;

	
	textureName		= "base/data/particles/dot";
	
	//animTexName		= "~/data/particles/dot";

	
	// Interpolation variables
	
	colors[0]     = "0 0.7 0.7 0.9";
	colors[1]     = "0 0.5 0.7 0.5";
	sizes[0]      = 0.30;
	sizes[1]      = 0.5;
};
datablock ParticleEmitterData(PRifleHALOTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;
   ejectionOffset = 0;
   thetaMin         = 0.0;
   thetaMax         = 0.0;  
   particles = PRifleHALOTrailParticle;
   useEmitterColors = False;
   uiName = "";
};

datablock AudioProfile(PRifleHALOShot1Sound)
{
   filename    = "./HAloRifle.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("PRifleHALO",   '<bitmap:base/client/ui/CI/generic> %1',    '%2 <bitmap:base/client/ui/CI/generic> %1',1,1);
datablock ProjectileData(PRifleHALOProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::PRifleHALO;
   radiusDamageType    = $DamageType::PRifleHALO;

   brickExplosionRadius = 0;
   brickExplosionImpact = False;          
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;     
   brickExplosionMaxVolumeFloating = 0;

   impactImpulse	     = 40;
   verticalImpulse	  = 40;
   explosion           = PrifleHALOExplosion;
   particleEmitter     = PRifleHALOTrailEmitter;

   muzzleVelocity      = 140;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 2000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};
datablock ItemData(PRifleHALOItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./PRifleHALO.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Plasma Rifle";
	iconName = "./icon_PRifleHALO";
	doColorShift = False;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	image = PRifleHALOImage;
	canDrop = true;
};
datablock ShapeBaseImageData(PRifleHALOImage)
{
   // Basic Item properties
   shapeFile = "./PRifleHALO.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   className = "WeaponImage";

   item = BowItem;
   ammo = " ";
   projectile = PRifleHALOProjectile;
   projectileType = Projectile;



   melee = false;

   armReady = true;

   doColorShift = Fasle;
   colorShiftColor = "0.2 0.2 0.2 1.000";//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]       = "Ready";

	stateSound[0]			= weaponswitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "smoke";
	stateTimeoutValue[2]            = 0.02;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitterTime[2]				= 0.05;
	stateEjectShell[2]       	  = false;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= PRifleHALOShot1Sound;
   stateSequence[2]                = "Fire";
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.0;
        stateTransitionOnTimeout[3]     = "Reload";



	stateName[4]			= "Reload";
	stateAllowImageChange[4]        = false;
	stateTimeoutValue[4]            = 0.2;
	stateWaitForTimeout[4]		= true;
	stateTransitionOnTimeout[4]     = "Check";
	//stateTransitionOnTriggerUp[4]     = "Ready";

	
	stateName[5]			= "Check";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "Ready";
	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.01;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		    = true;

	stateScript[6]                  = "onStopFire";
};

function PRifleHALOImage::onFire(%this,%obj,%slot) //Ephi's magic spread code
{
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"0")));
	%projectile = %this.projectile;
	%spread = 0.002;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

package PRifleHALOMelee
{
  	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		if(%player.getMountedImage(0) $= PRifleHALOImage.getID() && %slot $= 4 && %val)
		{
			%projectile = HaloMeleeProjectile;
			%vector = %player.getMuzzleVector(0);
			%objectVelocity = %player.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%p = new Projectile()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %player.getMuzzlePoint(0);
				sourceObject = %player;
				sourceSlot = 0;
				client = %player.client;
			};		
			%player.playthread("3","Activate");
			MissionCleanup.add(%p);
			return %p;
		}
		Parent::onTrigger(%this, %player, %slot, %val);
	}
};	
ActivatePackage(PRifleHALOMelee);